# esercizio1.s

            .text
            .globl main

main:       li $v0,4        # servizio print_string
            la $a0,menu
            syscall         # stampa il menu

err1:       li $v0,4        # servizio print_string
            la $a0,menuPrompt
            syscall         # stampa il prompt
            li $v0,5        # servizio read_int
            syscall         # legge un numero
            beq $v0,1,length
            beq $v0,2,count
            beq $v0,3,reverse
            bne $v0,4,err1
            jr $ra          # exit

length:     li $v0,4        # servizio print_string
            la $a0,strPrompt
            syscall         # stampa il prompt
            li $v0,8        # servizio read_string
            la $a0,strBuffer
            li $a1,256
            syscall         # legge una stringa

            la $t2,strBuffer # t2 punta a un carattere della stringa
            li $t1,0        # t1 conta la lunghezza
loop1:      lbu $t0,($t2)   # leggo un carattere della stringa
            beqz $t0,strEnd1 # se  zero ho finito
            addu $t1,$t1,1  # incremento il contatore
            addu $t2,$t2,1  # incremento la posizione sulla stringa
            j loop1         # e continuo
strEnd1:    li $v0,4        # servizio print_string
            la $a0,resPrompt+1
            syscall         # stampa il prompt
            li $v0,1        # servizio print_int
            subu $a0,$t1,1  # non conto acapo
            syscall         # stampa la lunghezza
            j main

count:      li $v0,4        # servizio print_string
            la $a0,strPrompt
            syscall         # stampa il prompt
            li $v0,8        # servizio read_string
            la $a0,strBuffer
            li $a1,256
            syscall         # legge una stringa
            li $v0,4        # servizio print_string
            la $a0,charPrompt
            syscall         # stampa il prompt
            li $v0,8        # servizio read_string
            la $a0,charBuffer
            li $a1,2
            syscall         # legge un carattere

            la $t1,strBuffer # t1 punta a un carattere della stringa
            li $t2,0        # t2 contatore occorrenze
            lbu $t3,charBuffer # t3 contiene il carattere da contare

loop2:      lbu $t0,($t1)   # leggo un carattere della stringa
            beqz $t0,strEnd2 # se  zero ho finito
            bne $t0,$t3,con # salto se  diverso dal carattere che cerco
            addu $t2,$t2,1  # incremento il contatore
con:        addu $t1,$t1,1  # incremento la posizione sulla stringa
            j loop2         # e continuo
strEnd2:    li $v0,4        # servizio print_string
            la $a0,resPrompt
            syscall         # stampa il prompt
            li $v0,1        # servizio print_int
            move $a0,$t2
            syscall         # stampa il numero di occorrenze
            j main

reverse:    li $v0,4        # servizio print_string
            la $a0,strPrompt
            syscall         # stampa il prompt
            li $v0,8        # servizio read_string
            la $a0,strBuffer
            li $a1,256
            syscall         # legge una stringa

            la $t1,strBuffer # $t1 indice di sinistra
            move $t2,$t1    # $t2 indice di destra

loop3:      lbu $t0,($t2)   # cerco la fine della stringa
            beqz $t0,loop4  # quando la raggiungo passo oltre
            addu $t2,$t2,1
            j loop3

loop4:      subu $t2,$t2,1  # tolgo 1 all'indice di destra
            bge $t1,$t2,end # se t1 >= t2 ho finito
            lbu $t3,($t1)   # carico i due caratteri da scambiare
            lbu $t4,($t2)
            sb $t3,($t2)    # e li scrivo scambiati di posto
            sb $t4,($t1)
            addu $t1,$t1,1  # aggiungo 1 all'indice di sinistra
            j loop4

end:        li $v0,4        # servizio print_string
            la $a0,resPrompt+1
            syscall         # stampa il prompt
            li $v0,4        # servizio print_string
            la $a0,strBuffer+1 # tolgo l'acapo
            syscall         # stampa il reverse
            j main

            .data
menu:       .asciiz "\n\nMenu:\n1) Lunghezza\n2) Occorrenze\n3) Reverse\n4) Esci\n"
menuPrompt: .asciiz "Scegli (1,2,3,4): "
resPrompt:  .asciiz "\nRisultato: "

strPrompt:  .asciiz "Inserisci una stringa: "
strBuffer:  .space 256
charPrompt: .asciiz "Inserisci un carattere: "
charBuffer: .space 2 # 1 + 1 acapo
